package boshclient

import (
	"fmt"
	"log"
	"net/http"
)

func (c *Client) GetDeployment(name string, logger *log.Logger) ([]byte, bool, error) {
	logger.Printf("getting manifest from bosh for deployment %s", name)
	respJSON := make(map[string]string)

	err := c.getDataFromBoshCheckingForErrors(
		fmt.Sprintf("%s/deployments/%s", c.boshURL, name),
		http.StatusOK,
		&respJSON,
		logger,
	)

	if err != nil {
		if deploymentDoesNotExistYet(err) {
			return nil, false, nil
		}
		return nil, false, err
	}

	return []byte(respJSON["manifest"]), true, nil
}

func deploymentDoesNotExistYet(err error) bool {
	e, ok := err.(unexpectedStatusError)
	return ok && e.actualStatus == http.StatusNotFound
}
