package boshclient

import "encoding/json"

type BoshTasks []BoshTask

func (t BoshTasks) IncompleteTasks() BoshTasks {
	return t.findTasksInStates(TaskIncomplete)
}

func (t BoshTasks) FailedTasks() BoshTasks {
	return t.findTasksInStates(TaskFailed)
}

func (t BoshTasks) DoneTasks() BoshTasks {
	return t.findTasksInStates(TaskDone)
}

func (t BoshTasks) findTasksInStates(stateType TaskStateType) BoshTasks {
	found := BoshTasks{}
	for _, task := range t {
		if task.StateType() == stateType {
			found = append(found, task)
		}
	}
	return found
}

func (t BoshTasks) ToLog() string {
	output, _ := json.Marshal(t)
	// json.Marshal will only return an error when the struct contains an
	// unsupported type. We know our struct does not, so we don't handle this
	// error.
	return string(output)
}
