package task_test

import (
	"io"

	. "github.com/onsi/ginkgo"
	. "github.com/onsi/gomega"

	"testing"

	"bytes"

	"log"

	"github.com/pivotal-cf/on-demand-service-broker/loggerfactory"
)

const (
	instanceID                    = "some-instance-id"
	existingPlanID                = "some-plan-id"
	existingPlanName              = "I'm a plan"
	existingPlanInstanceGroupName = "instance-group-name"
	secondPlanID                  = "another-plan"
	serviceOfferingID             = "service-id"
	deploymentName                = "a-fancy-deployment"
)

var (
	logBuffer     *bytes.Buffer
	loggerFactory *loggerfactory.LoggerFactory
	logger        *log.Logger
)

var _ = BeforeEach(func() {
	logBuffer = new(bytes.Buffer)
	loggerFactory = loggerfactory.New(io.MultiWriter(GinkgoWriter, logBuffer), "[broker-unit-tests] ", log.LstdFlags)
	logger = loggerFactory.NewLogger()
})

func TestTask(t *testing.T) {
	RegisterFailHandler(Fail)
	RunSpecs(t, "Task Suite")
}
